namespace CCI_ConfigSupport.Data;
        // class declarations
         class ConfigTemplate;
         class ConfigValueSet;
         class ConfigItem;
         class ConfigIntegerRangeItem;
         class ConfigStringItem;
         class ConfigSettings;
         class ConfigSettingsVC4TimeZone;
         class ConfigSettingsIPTableEntry;
         class IPTableTypes;
         class ConfigPanels;
         class ConfigFolder;
         class ConfigPanel;
         class ConfigIPAddressItem;
         class IPAddressValue;
         class ConfigSettingsTimeserver;
         class ConfigListItem;
         class ListValue;
         class ConfigTableSelector;
         class ConfigSettingsVC4DeviceMapping;
         class ConfigProject;
         class ConfigPrograms;
         class ConfigProgram;
         class ConfigSettingsTimeZone;
         class ConfigDMPS;
         class ConfigCategory;
         class ConfigBooleanItem;
         class ConfigXPanel;
           class ProgramSlots;
     class ConfigTemplate 
    {
        // class delegates

        // class events

        // class functions
        FUNCTION IncrementVersion ();
        FUNCTION Publish ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING Id[];
        STRING Description[];
        SIGNED_LONG_INTEGER Version;
        SIGNED_LONG_INTEGER PublishedVersion;
        STRING Folder[];
        ConfigPrograms Programs;
        ConfigPanels Panels;
    };

     class ConfigValueSet 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

    static class IPTableTypes // enum
    {
        static SIGNED_LONG_INTEGER Slave;
        static SIGNED_LONG_INTEGER Master;
    };

     class ConfigPanels 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class IPAddressValue 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING IPAddress[];
        INTEGER IPPort;
    };

     class ListValue 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING Value[];
        SIGNED_LONG_INTEGER Index;
    };

     class ConfigProject 
    {
        // class delegates

        // class events

        // class functions
        STRING_FUNCTION GetVC4ProgramInstanceName ();
        FUNCTION IncrementVersion ();
        FUNCTION Publish ();
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING ProjectName[];
        STRING CustomerName[];
        STRING BuildingName[];
        STRING RoomName[];
        STRING Programmer[];
        STRING Id[];
        STRING Description[];
        SIGNED_LONG_INTEGER Version;
        SIGNED_LONG_INTEGER PublishedVersion;
        STRING Folder[];
        ConfigPrograms Programs;
        ConfigPanels Panels;
    };

     class ConfigPrograms 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
        STRING IPAddress[];
        STRING AuthToken[];
    };

namespace CCI_ConfigSupport.Json;
        // class declarations
         class ConfigSerializerSettingsFactory;
         class ConfigDeserializerSettingsFactory;
     class ConfigSerializerSettingsFactory 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

     class ConfigDeserializerSettingsFactory 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

namespace CCI_ConfigSupport.CrestronToolBoxUtil;
        // class declarations
         class ToolBoxComm;
         class ProgramSlots;
     class ToolBoxComm 
    {
        // class delegates

        // class events

        // class functions
        SIGNED_LONG_INTEGER_FUNCTION GetHashCode ();
        STRING_FUNCTION ToString ();

        // class variables
        INTEGER __class_id__;

        // class properties
    };

    static class ProgramSlots // enum
    {
        static SIGNED_LONG_INTEGER Unknown;
        static SIGNED_LONG_INTEGER Program01;
        static SIGNED_LONG_INTEGER Program02;
        static SIGNED_LONG_INTEGER Program03;
        static SIGNED_LONG_INTEGER Program04;
        static SIGNED_LONG_INTEGER Program05;
        static SIGNED_LONG_INTEGER Program06;
        static SIGNED_LONG_INTEGER Program07;
        static SIGNED_LONG_INTEGER Program08;
        static SIGNED_LONG_INTEGER Program09;
        static SIGNED_LONG_INTEGER Program10;
    };

