using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;
using CCI.ConfigurationSuiteLite.Library.Model;
using CCI.ConfigurationSuiteLite.Library.Components;
using CCI.ConfigurationSuiteLite.Library;
using CCI.ConfigurationSuiteLite.Library.Events;
using CCI.ConfigurationSuiteLite.Library.Registration;
using CCI.SimplSharp.Library.File.Utilities;
using CCI.SimplSharp.Library.IO.Utilities;
using CCI.SimplSharp.Library.IO.Common;
using CCI_ConfigSupport.Data;
using CCI_ConfigSupport.Json;
using CCI_ConfigSupport.CrestronToolBoxUtil;
using CCI_WebConfig_Crestron;

namespace UserModule_CCI_CONFIG_ITEM_BOOLEAN_LITE
{
    public class UserModuleClass_CCI_CONFIG_ITEM_BOOLEAN_LITE : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        
        
        
        
        
        Crestron.Logos.SplusObjects.DigitalOutput VALUE;
        UShortParameter PROCESSORID;
        StringParameter UNIQUEID;
        UShortParameter CATEGORY;
        StringParameter DESCRIPTION;
        UShortParameter DEFAULTVALUE;
        StringParameter TRUETEXT;
        StringParameter FALSETEXT;
        CCI.ConfigurationSuiteLite.Library.Components.BooleanComponent ITEM;
        public void ONSTATEUPDATE ( object __sender__ /*CCI.ConfigurationSuiteLite.Library.Components.BooleanComponent SENDER */, CCI.ConfigurationSuiteLite.Library.Events.UInt16EventArgs ARGS ) 
            { 
            BooleanComponent  SENDER  = (BooleanComponent )__sender__;
            try
            {
                SplusExecutionContext __context__ = SplusSimplSharpDelegateThreadStartCode();
                
                __context__.SourceCodeLine = 138;
                VALUE  .Value = (ushort) ( ARGS.Payload ) ; 
                
                
            }
            finally { ObjectFinallyHandler(); }
            }
            
        public override object FunctionMain (  object __obj__ ) 
            { 
            try
            {
                SplusExecutionContext __context__ = SplusFunctionMainStartCode();
                
                __context__.SourceCodeLine = 152;
                WaitForInitializationComplete ( ) ; 
                __context__.SourceCodeLine = 154;
                // RegisterEvent( ITEM , ONSTATEUPDATE , ONSTATEUPDATE ) 
                try { g_criticalSection.Enter(); ITEM .OnStateUpdate  += ONSTATEUPDATE; } finally { g_criticalSection.Leave(); }
                ; 
                __context__.SourceCodeLine = 156;
                ITEM . SymbolID  =  ( GetSymbolInstanceName ( )  )  .ToString() ; 
                __context__.SourceCodeLine = 157;
                ITEM . Configure ( (ushort)( PROCESSORID  .Value ), UNIQUEID  .ToString(), (ushort)( CATEGORY  .Value ), DESCRIPTION  .ToString(), (ushort)( DEFAULTVALUE  .Value ), TRUETEXT  .ToString(), FALSETEXT  .ToString()) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler(); }
            return __obj__;
            }
            
        
        public override void LogosSplusInitialize()
        {
            _SplusNVRAM = new SplusNVRAM( this );
            
            VALUE = new Crestron.Logos.SplusObjects.DigitalOutput( VALUE__DigitalOutput__, this );
            m_DigitalOutputList.Add( VALUE__DigitalOutput__, VALUE );
            
            PROCESSORID = new UShortParameter( PROCESSORID__Parameter__, this );
            m_ParameterList.Add( PROCESSORID__Parameter__, PROCESSORID );
            
            CATEGORY = new UShortParameter( CATEGORY__Parameter__, this );
            m_ParameterList.Add( CATEGORY__Parameter__, CATEGORY );
            
            DEFAULTVALUE = new UShortParameter( DEFAULTVALUE__Parameter__, this );
            m_ParameterList.Add( DEFAULTVALUE__Parameter__, DEFAULTVALUE );
            
            UNIQUEID = new StringParameter( UNIQUEID__Parameter__, this );
            m_ParameterList.Add( UNIQUEID__Parameter__, UNIQUEID );
            
            DESCRIPTION = new StringParameter( DESCRIPTION__Parameter__, this );
            m_ParameterList.Add( DESCRIPTION__Parameter__, DESCRIPTION );
            
            TRUETEXT = new StringParameter( TRUETEXT__Parameter__, this );
            m_ParameterList.Add( TRUETEXT__Parameter__, TRUETEXT );
            
            FALSETEXT = new StringParameter( FALSETEXT__Parameter__, this );
            m_ParameterList.Add( FALSETEXT__Parameter__, FALSETEXT );
            
            
            
            _SplusNVRAM.PopulateCustomAttributeList( true );
            
            NVRAM = _SplusNVRAM;
            
        }
        
        public override void LogosSimplSharpInitialize()
        {
            ITEM  = new CCI.ConfigurationSuiteLite.Library.Components.BooleanComponent();
            
            
        }
        
        public UserModuleClass_CCI_CONFIG_ITEM_BOOLEAN_LITE ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}
        
        
        
        
        const uint VALUE__DigitalOutput__ = 0;
        const uint PROCESSORID__Parameter__ = 10;
        const uint UNIQUEID__Parameter__ = 11;
        const uint CATEGORY__Parameter__ = 12;
        const uint DESCRIPTION__Parameter__ = 13;
        const uint DEFAULTVALUE__Parameter__ = 14;
        const uint TRUETEXT__Parameter__ = 15;
        const uint FALSETEXT__Parameter__ = 16;
        
        [SplusStructAttribute(-1, true, false)]
        public class SplusNVRAM : SplusStructureBase
        {
        
            public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
            
            
        }
        
        SplusNVRAM _SplusNVRAM = null;
        
        public class __CEvent__ : CEvent
        {
            public __CEvent__() {}
            public void Close() { base.Close(); }
            public int Reset() { return base.Reset() ? 1 : 0; }
            public int Set() { return base.Set() ? 1 : 0; }
            public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
        }
        public class __CMutex__ : CMutex
        {
            public __CMutex__() {}
            public void Close() { base.Close(); }
            public void ReleaseMutex() { base.ReleaseMutex(); }
            public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
        }
         public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
    }
    
    
}
