using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using System.Linq;
using Crestron;
using Crestron.Logos.SplusLibrary;
using Crestron.Logos.SplusObjects;
using Crestron.SimplSharp;
using CCI.ConfigurationSuiteLite.Library.Model;
using CCI.ConfigurationSuiteLite.Library.Components;
using CCI.ConfigurationSuiteLite.Library;
using CCI.ConfigurationSuiteLite.Library.Events;
using CCI.ConfigurationSuiteLite.Library.Registration;
using CCI.SimplSharp.Library.File.Utilities;
using CCI.SimplSharp.Library.IO.Utilities;
using CCI.SimplSharp.Library.IO.Common;
using CCI_ConfigSupport.Data;
using CCI_ConfigSupport.Json;
using CCI_ConfigSupport.CrestronToolBoxUtil;
using CCI_WebConfig_Crestron;

namespace UserModule_CCI_CONFIG_ITEM_LIST_LITE
{
    public class UserModuleClass_CCI_CONFIG_ITEM_LIST_LITE : SplusObject
    {
        static CCriticalSection g_criticalSection = new CCriticalSection();
        
        
        
        
        
        
        
        
        Crestron.Logos.SplusObjects.AnalogOutput SELECTEDINDEX;
        Crestron.Logos.SplusObjects.StringOutput SELECTEDVALUE;
        UShortParameter PROCESSORID;
        StringParameter UNIQUEID;
        UShortParameter CATEGORY;
        StringParameter DESCRIPTION;
        UShortParameter DEFAULTINDEX;
        InOutArray<StringParameter> LISTITEM;
        CCI.ConfigurationSuiteLite.Library.Components.ListComponent ITEM;
        public void ONSTATEUPDATE ( object __sender__ /*CCI.ConfigurationSuiteLite.Library.Components.ListComponent SENDER */, CCI.ConfigurationSuiteLite.Library.Events.ListValueEventArgs ARGS ) 
            { 
            ListComponent  SENDER  = (ListComponent )__sender__;
            try
            {
                SplusExecutionContext __context__ = SplusSimplSharpDelegateThreadStartCode();
                
                __context__.SourceCodeLine = 132;
                SELECTEDINDEX  .Value = (ushort) ( ARGS.Index ) ; 
                __context__.SourceCodeLine = 133;
                SELECTEDVALUE  .UpdateValue ( ARGS . Value  ) ; 
                
                
            }
            finally { ObjectFinallyHandler(); }
            }
            
        public override object FunctionMain (  object __obj__ ) 
            { 
            ushort I = 0;
            
            CrestronString VALUE;
            VALUE  = new CrestronString( Crestron.Logos.SplusObjects.CrestronStringEncoding.eEncodingASCII, 255, this );
            
            CCI.ConfigurationSuiteLite.Library.Model.StringList VALUES;
            VALUES  = new CCI.ConfigurationSuiteLite.Library.Model.StringList();
            
            try
            {
                SplusExecutionContext __context__ = SplusFunctionMainStartCode();
                
                __context__.SourceCodeLine = 151;
                ushort __FN_FORSTART_VAL__1 = (ushort) ( 1 ) ;
                ushort __FN_FOREND_VAL__1 = (ushort)100; 
                int __FN_FORSTEP_VAL__1 = (int)1; 
                for ( I  = __FN_FORSTART_VAL__1; (__FN_FORSTEP_VAL__1 > 0)  ? ( (I  >= __FN_FORSTART_VAL__1) && (I  <= __FN_FOREND_VAL__1) ) : ( (I  <= __FN_FORSTART_VAL__1) && (I  >= __FN_FOREND_VAL__1) ) ; I  += (ushort)__FN_FORSTEP_VAL__1) 
                    { 
                    __context__.SourceCodeLine = 153;
                    if ( Functions.TestForTrue  ( ( Functions.BoolToInt ( Functions.Length( LISTITEM[ I ] ) > 0 ))  ) ) 
                        {
                        __context__.SourceCodeLine = 154;
                        VALUES . Add ( (ushort)( I ), LISTITEM[ I ] .ToString()) ; 
                        }
                    
                    __context__.SourceCodeLine = 151;
                    } 
                
                __context__.SourceCodeLine = 157;
                WaitForInitializationComplete ( ) ; 
                __context__.SourceCodeLine = 159;
                // RegisterEvent( ITEM , ONSTATEUPDATE , ONSTATEUPDATE ) 
                try { g_criticalSection.Enter(); ITEM .OnStateUpdate  += ONSTATEUPDATE; } finally { g_criticalSection.Leave(); }
                ; 
                __context__.SourceCodeLine = 161;
                ITEM . SymbolID  =  ( GetSymbolInstanceName ( )  )  .ToString() ; 
                __context__.SourceCodeLine = 162;
                ITEM . Configure ( (ushort)( PROCESSORID  .Value ), UNIQUEID  .ToString(), (ushort)( CATEGORY  .Value ), DESCRIPTION  .ToString(), (ushort)( DEFAULTINDEX  .Value ), VALUES) ; 
                
                
            }
            catch(Exception e) { ObjectCatchHandler(e); }
            finally { ObjectFinallyHandler(); }
            return __obj__;
            }
            
        
        public override void LogosSplusInitialize()
        {
            _SplusNVRAM = new SplusNVRAM( this );
            
            SELECTEDINDEX = new Crestron.Logos.SplusObjects.AnalogOutput( SELECTEDINDEX__AnalogSerialOutput__, this );
            m_AnalogOutputList.Add( SELECTEDINDEX__AnalogSerialOutput__, SELECTEDINDEX );
            
            SELECTEDVALUE = new Crestron.Logos.SplusObjects.StringOutput( SELECTEDVALUE__AnalogSerialOutput__, this );
            m_StringOutputList.Add( SELECTEDVALUE__AnalogSerialOutput__, SELECTEDVALUE );
            
            PROCESSORID = new UShortParameter( PROCESSORID__Parameter__, this );
            m_ParameterList.Add( PROCESSORID__Parameter__, PROCESSORID );
            
            CATEGORY = new UShortParameter( CATEGORY__Parameter__, this );
            m_ParameterList.Add( CATEGORY__Parameter__, CATEGORY );
            
            DEFAULTINDEX = new UShortParameter( DEFAULTINDEX__Parameter__, this );
            m_ParameterList.Add( DEFAULTINDEX__Parameter__, DEFAULTINDEX );
            
            UNIQUEID = new StringParameter( UNIQUEID__Parameter__, this );
            m_ParameterList.Add( UNIQUEID__Parameter__, UNIQUEID );
            
            DESCRIPTION = new StringParameter( DESCRIPTION__Parameter__, this );
            m_ParameterList.Add( DESCRIPTION__Parameter__, DESCRIPTION );
            
            LISTITEM = new InOutArray<StringParameter>( 255, this );
            for( uint i = 0; i < 255; i++ )
            {
                LISTITEM[i+1] = new StringParameter( LISTITEM__Parameter__ + i, LISTITEM__Parameter__, this );
                m_ParameterList.Add( LISTITEM__Parameter__ + i, LISTITEM[i+1] );
            }
            
            
            
            _SplusNVRAM.PopulateCustomAttributeList( true );
            
            NVRAM = _SplusNVRAM;
            
        }
        
        public override void LogosSimplSharpInitialize()
        {
            ITEM  = new CCI.ConfigurationSuiteLite.Library.Components.ListComponent();
            
            
        }
        
        public UserModuleClass_CCI_CONFIG_ITEM_LIST_LITE ( string InstanceName, string ReferenceID, Crestron.Logos.SplusObjects.CrestronStringEncoding nEncodingType ) : base( InstanceName, ReferenceID, nEncodingType ) {}
        
        
        
        
        const uint SELECTEDINDEX__AnalogSerialOutput__ = 0;
        const uint SELECTEDVALUE__AnalogSerialOutput__ = 1;
        const uint PROCESSORID__Parameter__ = 10;
        const uint UNIQUEID__Parameter__ = 11;
        const uint CATEGORY__Parameter__ = 12;
        const uint DESCRIPTION__Parameter__ = 13;
        const uint DEFAULTINDEX__Parameter__ = 14;
        const uint LISTITEM__Parameter__ = 15;
        
        [SplusStructAttribute(-1, true, false)]
        public class SplusNVRAM : SplusStructureBase
        {
        
            public SplusNVRAM( SplusObject __caller__ ) : base( __caller__ ) {}
            
            
        }
        
        SplusNVRAM _SplusNVRAM = null;
        
        public class __CEvent__ : CEvent
        {
            public __CEvent__() {}
            public void Close() { base.Close(); }
            public int Reset() { return base.Reset() ? 1 : 0; }
            public int Set() { return base.Set() ? 1 : 0; }
            public int Wait( int timeOutInMs ) { return base.Wait( timeOutInMs ) ? 1 : 0; }
        }
        public class __CMutex__ : CMutex
        {
            public __CMutex__() {}
            public void Close() { base.Close(); }
            public void ReleaseMutex() { base.ReleaseMutex(); }
            public int WaitForMutex() { return base.WaitForMutex() ? 1 : 0; }
        }
         public int IsNull( object obj ){ return (obj == null) ? 1 : 0; }
    }
    
    
}
